Index: /NEMO/trunk/src/OCE/SBC/sbcblk.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk.F90	(revision 12628)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk.F90	(revision 12629)
@@ -1036,5 +1036,5 @@
       evap_ice (:,:,:) = rn_efac * qla_ice (:,:,:) * z1_rLsub    ! sublimation
       devap_ice(:,:,:) = rn_efac * dqla_ice(:,:,:) * z1_rLsub    ! d(sublimation)/dT
-      zevap    (:,:)   = rn_efac * ( emp(:,:) + tprecip(:,:) )   ! evaporation over ocean  !LB: should we remove rn_efac here???
+      zevap    (:,:)   = emp(:,:) + tprecip(:,:)   ! evaporation over ocean  !LB: removed rn_efac here, correct???
 
       ! --- evaporation minus precipitation --- !
Index: /NEMO/trunk/tests/STATION_ASF/EXPREF/plot_station_asf.py
===================================================================
--- /NEMO/trunk/tests/STATION_ASF/EXPREF/plot_station_asf.py	(revision 12628)
+++ /NEMO/trunk/tests/STATION_ASF/EXPREF/plot_station_asf.py	(revision 12629)
@@ -53,6 +53,6 @@
 L_VARL  = [ r'$Q_{lat}$', r'$Q_{sens}$' , r'$Q_{net}$' , r'$Q_{lw}$' , r'$|\tau|$' , r'$\Delta T_{skin}$' ] ; # name of variable in latex mode
 L_VUNT  = [ r'$W/m^2$'  , r'$W/m^2$'    , r'$W/m^2$'   , r'$W/m^2$'  , r'$N/m^2$'  ,      'K'             ]
-L_VMAX  = [     75.     ,     75.       ,    800.      ,     25.     ,    1.2      ,      -0.7            ]
-L_VMIN  = [   -250.     ,   -125.       ,   -400.      ,   -150.     ,    0.       ,       0.7            ]
+L_VMAX  = [     75.     ,     75.       ,    800.      ,     25.     ,    1.2      ,       0.7            ]
+L_VMIN  = [   -250.     ,   -125.       ,   -400.      ,   -150.     ,    0.       ,      -0.7            ]
 L_ANOM  = [   True      ,    True       ,    True      ,    True     ,   True      ,      False           ]
 
Index: /NEMO/trunk/tests/STATION_ASF/MY_SRC/sbcssm.F90
===================================================================
--- /NEMO/trunk/tests/STATION_ASF/MY_SRC/sbcssm.F90	(revision 12628)
+++ /NEMO/trunk/tests/STATION_ASF/MY_SRC/sbcssm.F90	(revision 12629)
@@ -54,5 +54,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/SAS 4.0 , NEMO Consortium (2018)
-   !! $Id: sbcssm.F90 12377 2020-02-12 14:39:06Z acc $
+   !! $Id: sbcssm.F90 12615 2020-03-26 15:18:49Z laurent $
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
Index: /NEMO/trunk/tests/STATION_ASF/MY_SRC/step_c1d.F90
===================================================================
--- /NEMO/trunk/tests/STATION_ASF/MY_SRC/step_c1d.F90	(revision 12628)
+++ /NEMO/trunk/tests/STATION_ASF/MY_SRC/step_c1d.F90	(revision 12629)
@@ -64,4 +64,7 @@
       CALL sbc    ( kstp, Nbb, Nnn )  ! Sea Boundary Condition (including sea-ice)
 
+      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+      ! diagnostics and outputs
+      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       CALL dia_wri( kstp, Nnn )  ! ocean model: outputs
 
Index: /NEMO/trunk/tests/STATION_ASF/MY_SRC/usrdef_hgr.F90
===================================================================
--- /NEMO/trunk/tests/STATION_ASF/MY_SRC/usrdef_hgr.F90	(revision 12628)
+++ /NEMO/trunk/tests/STATION_ASF/MY_SRC/usrdef_hgr.F90	(revision 12629)
@@ -14,5 +14,5 @@
    !!   usr_def_hgr   : initialize the horizontal mesh 
    !!----------------------------------------------------------------------
-   USE dom_oce  , ONLY: nimpp, njmpp        ! ocean space and time domain
+   USE dom_oce  , ONLY: nimpp, njmpp       ! ocean space and time domain
    USE c1d      ,  ONLY: rn_lon1d, rn_lat1d ! ocean lon/lat define by namelist
    USE par_oce        ! ocean space and time domain
@@ -30,5 +30,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: usrdef_hgr.F90 10072 2018-08-28 15:21:50Z nicolasmartin $
+   !! $Id: usrdef_hgr.F90 12489 2020-02-28 15:55:11Z davestorkey $ 
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -54,5 +54,5 @@
       !!
       !! ** Action  : - define longitude & latitude of t-, u-, v- and f-points (in degrees) 
-      !!              - define coriolis parameter at f-point if the domain in not on the sphere
+      !!              - define coriolis parameter at f-point if the domain in not on the sphere (on beta-plane)
       !!              - define i- & j-scale factors at t-, u-, v- and f-points (in meters)
       !!              - define u- & v-surfaces (if gridsize reduction is used in some straits) (in m2)
Index: /NEMO/trunk/tests/STATION_ASF/MY_SRC/usrdef_nam.F90
===================================================================
--- /NEMO/trunk/tests/STATION_ASF/MY_SRC/usrdef_nam.F90	(revision 12628)
+++ /NEMO/trunk/tests/STATION_ASF/MY_SRC/usrdef_nam.F90	(revision 12629)
@@ -8,5 +8,5 @@
    !!======================================================================
    !! History :  4.0  ! 2016-03  (S. Flavoni, G. Madec)  Original code
-   !! History :  4.x  ! 2019-10  (L. Brodeau) for STATION_ASF (C1D meets SAS)
+   !!            4.x  ! 2019-10  (L. Brodeau) for STATION_ASF (C1D meets SAS)
    !!----------------------------------------------------------------------
 
@@ -15,6 +15,6 @@
    !!   usr_def_hgr   : initialize the horizontal mesh 
    !!----------------------------------------------------------------------
-   USE dom_oce  , ONLY: nimpp, njmpp             ! ocean space and time domain
-   USE dom_oce  , ONLY: ln_zco, ln_zps, ln_sco   ! flag of type of coordinate
+   USE dom_oce  , ONLY: nimpp, njmpp       ! ocean space and time domain
+!!!   USE dom_oce  , ONLY: ln_zco, ln_zps, ln_sco   ! flag of type of coordinate
    USE par_oce        ! ocean space and time domain
    USE phycst         ! physical constants
@@ -33,5 +33,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: usrdef_nam.F90 11536 2019-09-11 13:54:18Z smasson $ 
+   !! $Id: usrdef_nam.F90 12377 2020-02-12 14:39:06Z acc $ 
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -68,8 +68,8 @@
       kk_cfg = 0
 
-      ! Global Domain size: STATION_ASF domain is 3 x 3 grid-points x 75 or vertical levels
+      ! Global Domain size: STATION_ASF domain is 3 x 3 grid-points x 2 or vertical levels
       kpi = 3
       kpj = 3
-      kpk = 1
+      kpk = 2    ! 2, rather than 1, because 1 would cause some issues... like overflow in array boundary indexes, etc...
       !
       !                             ! Set the lateral boundary condition of the global domain
Index: /NEMO/trunk/tests/STATION_ASF/MY_SRC/usrdef_zgr.F90
===================================================================
--- /NEMO/trunk/tests/STATION_ASF/MY_SRC/usrdef_zgr.F90	(revision 12628)
+++ /NEMO/trunk/tests/STATION_ASF/MY_SRC/usrdef_zgr.F90	(revision 12629)
@@ -1,19 +1,21 @@
 MODULE usrdef_zgr
    !!======================================================================
-   !!                     ***  MODULE usrdef_zgr  ***
+   !!                       ***  MODULE  usrdef_zgr  ***
    !!
    !!                       ===  STATION_ASF case  ===
    !!
-   !! user defined :  vertical coordinate system of a user configuration
+   !! User defined : vertical coordinate system of a user configuration
    !!======================================================================
-   !! History :  4.0  ! 2019-10  (L. Brodeau)  Original code
+   !! History :  4.0  ! 2016-06  (G. Madec)  Original code
+   !!            4.x  ! 2019-10  (L. Brodeau) Station ASF
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   usr_def_zgr   : user defined vertical coordinate system (required)
+   !!   usr_def_zgr   : user defined vertical coordinate system
+   !!      zgr_z      : reference 1D z-coordinate 
+   !!      zgr_top_bot: ocean top and bottom level indices
+   !!      zgr_zco    : 3D verticl coordinate in pure z-coordinate case
    !!---------------------------------------------------------------------
    USE oce            ! ocean variables
-   !USE dom_oce        ! ocean domain
-   !USE depth_e3       ! depth <=> e3
    USE usrdef_nam     ! User defined : namelist variables
    !
@@ -21,14 +23,13 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE timing         ! Timing
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   usr_def_zgr   ! called by domzgr.F90
+   PUBLIC   usr_def_zgr        ! called by domzgr.F90
 
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: usrdef_zgr.F90 10072 2018-08-28 15:21:50Z nicolasmartin $
+   !! $Id: usrdef_zgr.F90 12377 2020-02-12 14:39:06Z acc $
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -47,12 +48,12 @@
       !!
       !!----------------------------------------------------------------------
-      LOGICAL                   , INTENT(  out) ::   ld_zco, ld_zps, ld_sco      ! vertical coordinate flags ( read in namusr_def )
-      LOGICAL                   , INTENT(  out) ::   ld_isfcav                   ! under iceshelf cavity flag
-      REAL(wp), DIMENSION(:)    , INTENT(  out) ::   pdept_1d, pdepw_1d          ! 1D grid-point depth     [m]
-      REAL(wp), DIMENSION(:)    , INTENT(  out) ::   pe3t_1d , pe3w_1d           ! 1D grid-point depth     [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pdept, pdepw                ! grid-point depth        [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pe3t , pe3u , pe3v , pe3f   ! vertical scale factors  [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pe3w , pe3uw, pe3vw         ! i-scale factors
-      INTEGER , DIMENSION(:,:)  , INTENT(  out) ::   k_top, k_bot                ! first & last ocean level
+      LOGICAL                   , INTENT(out) ::   ld_zco, ld_zps, ld_sco      ! vertical coordinate flags
+      LOGICAL                   , INTENT(out) ::   ld_isfcav                   ! under iceshelf cavity flag
+      REAL(wp), DIMENSION(:)    , INTENT(out) ::   pdept_1d, pdepw_1d          ! 1D grid-point depth     [m]
+      REAL(wp), DIMENSION(:)    , INTENT(out) ::   pe3t_1d , pe3w_1d           ! 1D grid-point depth     [m]
+      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   pdept, pdepw                ! grid-point depth        [m]
+      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   pe3t , pe3u , pe3v , pe3f   ! vertical scale factors  [m]
+      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   pe3w , pe3uw, pe3vw         ! i-scale factors 
+      INTEGER , DIMENSION(:,:)  , INTENT(out) ::   k_top, k_bot                ! first & last ocean level
       !!----------------------------------------------------------------------
       !
@@ -61,10 +62,13 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
       !
-
+      !
+      ! type of vertical coordinate
+      ! ---------------------------
       ld_zco    = .TRUE.         ! z-coordinate without ocean cavities
       ld_zps    = .FALSE.
       ld_sco    = .FALSE.
       ld_isfcav = .FALSE.
-      
+
+      !! 1st level (the only one that matters)
       pdept_1d(1) = rn_dept1 ! depth (m) at which the SST is taken/measured == depth of first T point!
       pdepw_1d(1) = 0._wp
@@ -72,16 +76,33 @@
       pe3w_1d(1)  = rn_dept1 ! LB???
 
-      pdept(:,:,:) = rn_dept1
-      pdepw(:,:,:) = 0._wp
-      pe3t(:,:,:) = 2._wp*rn_dept1
-      pe3u(:,:,:) = 2._wp*rn_dept1
-      pe3v(:,:,:) = 2._wp*rn_dept1
-      pe3f(:,:,:) = 2._wp*rn_dept1
-      pe3w(:,:,:)  = rn_dept1  ! LB???
-      pe3uw(:,:,:) = rn_dept1  ! LB???
-      pe3vw(:,:,:) = rn_dept1  ! LB???
+      pdept(:,:,1) = rn_dept1
+      pdepw(:,:,1) = 0._wp
+      pe3t(:,:,1) = 2._wp*rn_dept1
+      pe3u(:,:,1) = 2._wp*rn_dept1
+      pe3v(:,:,1) = 2._wp*rn_dept1
+      pe3f(:,:,1) = 2._wp*rn_dept1
+      pe3w(:,:,1)  = rn_dept1  ! LB???
+      pe3uw(:,:,1) = rn_dept1  ! LB???
+      pe3vw(:,:,1) = rn_dept1  ! LB???
+      
+      !! 2nd level, technically useless (only for the sake of code stability)
+      pdept_1d(2) = 3._wp*rn_dept1
+      pdepw_1d(2) = 2._wp*rn_dept1
+      pe3t_1d(2)  = 2._wp*rn_dept1
+      pe3w_1d(2)  = 2._wp*rn_dept1
+
+      pdept(:,:,2) = 3._wp*rn_dept1
+      pdepw(:,:,2) = 2._wp*rn_dept1
+      pe3t(:,:,2) = 2._wp*rn_dept1
+      pe3u(:,:,2) = 2._wp*rn_dept1
+      pe3v(:,:,2) = 2._wp*rn_dept1
+      pe3f(:,:,2) = 2._wp*rn_dept1
+      pe3w(:,:,2)  = 2._wp*rn_dept1
+      pe3uw(:,:,2) = 2._wp*rn_dept1
+      pe3vw(:,:,2) = 2._wp*rn_dept1
+
       k_top = 1
       k_bot = 1
-      !
+
    END SUBROUTINE usr_def_zgr
    !!======================================================================