Index: /utils/CI/sette/BATCH_TEMPLATE/batch-X64_IRENE_GCC
===================================================================
--- /utils/CI/sette/BATCH_TEMPLATE/batch-X64_IRENE_GCC	(revision 12653)
+++ /utils/CI/sette/BATCH_TEMPLATE/batch-X64_IRENE_GCC	(revision 12653)
@@ -0,0 +1,87 @@
+#!/bin/bash
+#MSUB -T 2000                # elapsed time limit in seconds   (60 minutes)
+#MSUB -r SETTE_JOB           # Job name
+#MSUB -o sette.jobid_%I.txt  # standard output
+#MSUB -e sette.jobid_%I.txt  # standard error
+#MSUB -n NPROCS              # Total number of mpi task to use
+#MSUB -A   gen7451          # project name
+#MSUB -q   skylake          # (queue name) only for thin nodes
+#MSUB -m store,work,scratch
+##########################################################################
+#
+# Test specific settings. Do not hand edit these lines; the fcm_job.sh script will set these
+# (via sed operating on this template job file). 
+#
+  OCEANCORES=NPROCS
+  export SETTE_DIR=DEF_SETTE_DIR
+#
+# set up mpp computing environment
+#
+  set +vx
+  module purge
+  module load gnu/8.3.0
+  module load flavor/buildcompiler/gcc/8
+  module load flavor/buildmpi/openmpi/2.0
+  module load flavor/hdf5/parallel
+  module load mpi/openmpi/2.0.4
+  module load hdf5/1.8.20
+  module load netcdf-c/4.6.0
+  module load netcdf-fortran/4.4.4
+#
+# Local settings for machine BULL (TITANE at CCRT France)
+#
+  export MPIRUN="ccc_mprun -n $OCEANCORES"
+
+#
+# load sette functions (only post_test_tidyup needed)
+#
+  . ${SETTE_DIR}/all_functions.sh
+#
+
+# modules to load
+
+# Don't remove neither change the following line
+# BODY
+
+#
+# These variables are needed by post_test_tidyup function in all_functions.sh
+#
+  export EXE_DIR=DEF_EXE_DIR
+  export INPUT_DIR=DEF_INPUT_DIR
+  export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
+  export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
+  export NEW_CONF=DEF_NEW_CONF
+  export CMP_NAM=DEF_CMP_NAM
+  export TEST_NAME=DEF_TEST_NAME
+#
+# end of set up
+###############################################################
+#
+# change to the working directory 
+#
+cd ${EXE_DIR}
+
+  echo Running on host `hostname`
+  echo Time is `date`
+  echo Directory is `pwd`
+# 
+#  Run the parallel MPI executable 
+#
+  echo "Running time ${MPIRUN} ./nemo"
+#
+  if [ MPI_FLAG == "yes" ]; then
+     time ${MPIRUN} ./nemo
+  else
+     time ./nemo
+  fi
+
+#
+  post_test_tidyup
+
+# END_BODY
+# Don't remove neither change the previous line
+
+
+  exit
+
Index: /utils/CI/sette/BATCH_TEMPLATE/batch-X64_IRENE_GCC_DEBUG
===================================================================
--- /utils/CI/sette/BATCH_TEMPLATE/batch-X64_IRENE_GCC_DEBUG	(revision 12653)
+++ /utils/CI/sette/BATCH_TEMPLATE/batch-X64_IRENE_GCC_DEBUG	(revision 12653)
@@ -0,0 +1,87 @@
+#!/bin/bash
+#MSUB -T 4000                # elapsed time limit in seconds   (60 minutes)
+#MSUB -r SETTE_JOB           # Job name
+#MSUB -o sette.jobid_%I.txt  # standard output
+#MSUB -e sette.jobid_%I.txt  # standard error
+#MSUB -n NPROCS              # Total number of mpi task to use
+#MSUB -A   gen7451          # project name
+#MSUB -q   skylake          # (queue name) only for thin nodes
+#MSUB -m store,work,scratch
+##########################################################################
+#
+# Test specific settings. Do not hand edit these lines; the fcm_job.sh script will set these
+# (via sed operating on this template job file). 
+#
+  OCEANCORES=NPROCS
+  export SETTE_DIR=DEF_SETTE_DIR
+#
+# set up mpp computing environment
+#
+  set +vx
+  module purge
+  module load gnu/8.3.0
+  module load flavor/buildcompiler/gcc/8
+  module load flavor/buildmpi/openmpi/2.0
+  module load flavor/hdf5/parallel
+  module load mpi/openmpi/2.0.4
+  module load hdf5/1.8.20
+  module load netcdf-c/4.6.0
+  module load netcdf-fortran/4.4.4
+#
+# Local settings for machine BULL (TITANE at CCRT France)
+#
+  export MPIRUN="ccc_mprun -n $OCEANCORES"
+
+#
+# load sette functions (only post_test_tidyup needed)
+#
+  . ${SETTE_DIR}/all_functions.sh
+#
+
+# modules to load
+
+# Don't remove neither change the following line
+# BODY
+
+#
+# These variables are needed by post_test_tidyup function in all_functions.sh
+#
+  export EXE_DIR=DEF_EXE_DIR
+  export INPUT_DIR=DEF_INPUT_DIR
+  export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
+  export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
+  export NEW_CONF=DEF_NEW_CONF
+  export CMP_NAM=DEF_CMP_NAM
+  export TEST_NAME=DEF_TEST_NAME
+#
+# end of set up
+###############################################################
+#
+# change to the working directory 
+#
+cd ${EXE_DIR}
+
+  echo Running on host `hostname`
+  echo Time is `date`
+  echo Directory is `pwd`
+# 
+#  Run the parallel MPI executable 
+#
+  echo "Running time ${MPIRUN} ./nemo"
+#
+  if [ MPI_FLAG == "yes" ]; then
+     time ${MPIRUN} ./nemo
+  else
+     time ./nemo
+  fi
+
+#
+  post_test_tidyup
+
+# END_BODY
+# Don't remove neither change the previous line
+
+
+  exit
+