Index: /utils/tools_CPL_OASIS_ticket2379_2020/TOYATM/EXP/namcouple
===================================================================
--- /utils/tools_CPL_OASIS_ticket2379_2020/TOYATM/EXP/namcouple	(revision 12668)
+++ /utils/tools_CPL_OASIS_ticket2379_2020/TOYATM/EXP/namcouple	(revision 12669)
@@ -11,5 +11,5 @@
 ############################################
  $RUNTIME 
-259200
+864000
  $END
 ############################################
@@ -19,5 +19,5 @@
 ############################################
  $STRINGS 
-O_SSTSST ATSSTSST 1 28800 3 rst.nc EXPORTED
+O_TepMix ATSSTSST 1 5400 3 rst.nc EXPOUT
 182 149 180 90 torc lmdz
 P 2 P 0 
@@ -27,5 +27,5 @@
 INT=1
 #
-ATSOLFLX O_QnsMix 1 28800 4 rst.nc EXPORTED
+ATSOLFLX O_QnsMix 1 5400 4 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -36,5 +36,5 @@
 INT=1
 #
-ATSOLFLX O_QnsIce 1 28800 4 rst.nc EXPORTED
+ATSOLFLX O_QnsIce 1 5400 4 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -45,5 +45,5 @@
 INT=1
 #
-ATSOLFLX O_QsrIce 1 28800 4 rst.nc EXPORTED
+ATSOLFLX O_QsrIce 1 5400 4 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -54,5 +54,5 @@
 INT=1
 #
-ATSOLFLX O_QsrMix 1 28800 4 rst.nc EXPORTED
+ATSOLFLX O_QsrMix 1 5400 4 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -63,5 +63,5 @@
 INT=1
 #
-ATSOLFLX O_dQnsdT 1 28800 4 rst.nc EXPORTED
+ATSOLFLX O_dQnsdT 1 5400 4 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -72,5 +72,5 @@
 INT=1
 #
-ATSOLFLX O_OTaux1 1 28800 4 rst.nc EXPORTED
+ATSOLFLX O_OTaux1 1 5400 4 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -81,5 +81,5 @@
 INT=1
 #
-ATSOLFLX O_OTauy1 1 28800 4 rst.nc EXPORTED
+ATSOLFLX O_OTauy1 1 5400 4 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -90,5 +90,5 @@
 INT=1
 #
-ATFLXEMP OTotRain 1 28800 3 rst.nc EXPORTED
+ATFLXEMP OTotRain 1 5400 3 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -98,5 +98,5 @@
 INT=1
 #
-ATFLXEMP OTotSnow 1 28800 3 rst.nc EXPORTED
+ATFLXEMP OTotSnow 1 5400 3 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -106,5 +106,5 @@
 INT=1
 #
-ATFLXEMP OTotEvap 1 28800 3 rst.nc EXPORTED
+ATFLXEMP OTotEvap 1 5400 3 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
@@ -114,5 +114,5 @@
 INT=1
 #
-ATFLXEMP OIceEvap 1 28800 3 rst.nc EXPORTED
+ATFLXEMP OIceEvap 1 5400 3 rst.nc EXPOUT
 180 90 182 149 lmdz torc
 P 0 P 2 
Index: /utils/tools_CPL_OASIS_ticket2379_2020/TOYATM/src/toyatm.F90
===================================================================
--- /utils/tools_CPL_OASIS_ticket2379_2020/TOYATM/src/toyatm.F90	(revision 12668)
+++ /utils/tools_CPL_OASIS_ticket2379_2020/TOYATM/src/toyatm.F90	(revision 12669)
@@ -66,11 +66,9 @@
   LOGICAL                       :: ln_rstart, nn_date0, nn_time0, nn_leapy  , nn_istate, nn_stock, nn_write ,nn_chunksz, nn_euler,nn_wxios
   CHARACTER (len=256)           :: cn_exp , cn_ocerst_in, cn_ocerst_indir, cn_ocerst_out, cn_ocerst_outdir
-  REAL (kind=wp)                :: rn_rdt
+  REAL (kind=wp)                :: rn_Dt
   LOGICAL                       :: ln_linssh, ln_crs, ln_meshmask
-  REAL (kind=wp)                :: rn_isfhmin, rn_atfp
+  REAL (kind=wp)                ::  rn_atfp
   !
   ! NEMO namelists
-!!  NAMELIST/namrun/ nn_it000, nn_itend
-!!  NAMELIST/namdom/ rn_rdt
       NAMELIST/namrun/ cn_ocerst_indir, cn_ocerst_outdir, nn_stocklist, ln_rst_list,                 &
          &             nn_no   , cn_exp   , cn_ocerst_in, cn_ocerst_out, ln_rstart , nn_rstctl ,     &
@@ -78,5 +76,5 @@
          &             nn_stock, nn_write , ln_mskland  , ln_clobber   , nn_chunksz, nn_euler  ,     &
          &             ln_cfmeta, ln_iscpl, ln_xios_read, nn_wxios
-      NAMELIST/namdom/ ln_linssh, rn_isfhmin, rn_rdt, rn_atfp, ln_crs, ln_meshmask
+      NAMELIST/namdom/ ln_linssh, rn_Dt, rn_atfp, ln_crs, ln_meshmask
   !
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -133,5 +131,5 @@
   !
 ! Get time step and number of iterations from ocean
-  time_step = INT(rn_rdt)
+  time_step = INT(rn_Dt)
   niter = nn_itend - nn_it000 + 1 
   !